#include "macros"

DATA:	arg:	0
	res:	0

TEXT:

head:	READINT(arg)
	arg	ZERO	STOP
	PUSH(arg)
	CALL(fact,x1)
x1:	POP(res)
	WRITEINT(res)
	GOTO(head)

;
; Recursive factorial routine
;

DATA:	rfact:	0		; Return address
	afact:	0		; Argument
	tfact:	0		; Result
	t:	0		; Temporary

TEXT:	fact:
; Get the argument without disturbing the return address
	POP(rfact)
	POP(afact)
	PUSH(rfact)

; Check for termination condition
	MOV(ONE,tfact)
	BLE(afact,ONE,fact2)

; Save argument
	PUSH(afact)

; Recursively call factorial
; t := FACT(afact-1)
	afact	ONE	.+1
	PUSH(afact)
	CALL(fact,fact1)
fact1:	POP(t)

; Restore argument
	POP(afact)

; tfact := afact * FACT(afact-1)
	MUL(afact,t,tfact)

; Clean up - put result BELOW return address
fact2:	POP(rfact)
	PUSH(tfact)
	PUSH(rfact)

	RET
